unit StringTable;

// Code by Schmackbolzen

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils,GenericDynArray;

type TStringTable = object
   private
       type RString=record
         content:string;
         offset:cardinal;
         end;
      var
      Strings:specialize TGenericDynArray<RString>;
      public
      function LoadStringTable(const FileStream:TStream;const offset:int64):boolean;
      function GetStringAtOffset(Offset:Cardinal):string; inline;
      end;

implementation

  uses math;

function TStringtable.GetStringAtOffset(Offset:Cardinal):string;inline;
var i:Integer;
begin
 result:='';
 for i := 0 to Strings.high do
  if Strings.GetAtIndex(i)^.offset = Offset then
   begin
    result:=Strings.GetAtIndex(i)^.content;
    break;
   end;
end;

function TStringtable.LoadStringTable(const FileStream:TStream;const offset:int64):boolean;
var StartingPos:int64;
    bufChar:array [0..3] of char;
    tempStr:string;
    posZero:byte;
    i:integer;
    newString:boolean;
    LastOffset:cardinal;

begin
 Strings.init;

 result:=false;
 StartingPos:=FileStream.Position;

 if FileStream.Seek(offset,fsFromBeginning) <> -1 then
  begin
   tempStr:='';
   LastOffset:=offset;
   while FileStream.Position < FileStream.Size do
   begin
     newString:=false;

     FileStream.ReadBuffer(bufChar,min(FileStream.Size - FileStream.Position,4)); //4 byte blocks until end

     for i := 0 to 3 do
      if ord(bufChar[i])=0 then
       begin
        newString:=true;
        posZero:=i;
        break;
       end;
     if not newString then
      tempStr:=tempStr+bufChar

     else
      begin
       tempStr:=tempStr+copy(bufChar,0,posZero);
       Strings.AppendOne;
       strings.GetLastEntry^.content:=tempStr;
       strings.GetLastEntry^.offset:=LastOffset-offset;
       LastOffset:=FileStream.Position-(4-posZero-1);
       tempStr:='';
       for i := posZero+1 to 3 do
       tempStr:=tempStr+bufChar[i];

      end;
   end;
   FileStream.Seek(StartingPos,fsFromBeginning);
   result:=true;
  end
end;

end.

